<?php
require_once (PATH_CONTROLLERS . "Common.php") ;
require_once (PATH_MODELS . "admin/LanguageTypeClass.php") ;

class LanguageType extends ControllerBase {
	private $type = "" ;
	function __construct() {
		$this->db = $_SESSION[SE_DB] ;
	}
	function __destruct() {
		unset($this->db) ;
	}
	public function processRequest($params) {
		$this->type = REQ_VIEW ;
		
		try {
			$this->db->open() ;
			if (isset($params) && count($params) > 0) {
				if (isset($params['type']))
					$this->type = $params['type'] ;
			}
			switch ($this->type) {
				case REQ_ADD:
					$this->addRecord($params) ;
					break ;
				case REQ_UPDATE:
					$this->updateRecord($params) ;
					break ;
				case REQ_DELETE:
					$this->deleteRecord($params) ;
					break ;
				case REQ_GET:
					$this->getRecord($params) ;
					break ;
				case REQ_LIST:
					$this->getList($params) ;
					break ;
				case REQ_REPORT:
					$this->getReport($params) ;
					break ;
				case REQ_VIEW:
					$this->getView() ;
					break ;
				default:
					$this->sendJsonResponse(Status::Error,"invalid request.","",$this->type) ;
					break ;
			}
			$this->db->close() ;
			return true ;
		} catch (Exception $e) {
			$this->db->close() ;
			die ($e->getMessage()) ;
		}
	}
	private function addRecord($params) {
		$cls = new LanguageTypeClass($this->db) ;
		$datas = array() ;
		$modifyby = $_SESSION[SE_USERID] ;
		$modifydate = date_create('now')->format('Y-m-d H:i:s') ;
		$ws = $_SESSION[SE_REMOTE_IP] ;
		
		$datas[] = $this->db->fieldValue(LanguageTypeTable::C_DESC,$this->getParam($params,'desc',"")) ;
		$datas[] = $this->db->fieldValue(LanguageTypeTable::C_REF,$this->getParam($params,'ref',"")) ;
		$datas[] = $this->db->fieldValue(LanguageTypeTable::C_DISPLAY,$this->getParam($params,'display',"")) ;
		$datas[] = $this->db->fieldValue(LanguageTypeTable::C_WS_ID,$ws) ;
		$datas[] = $this->db->fieldValue(LanguageTypeTable::C_MODIFY_BY,$modifyby) ;
		$datas[] = $this->db->fieldValue(LanguageTypeTable::C_CREATE_BY,$modifyby) ;
		$datas[] = $this->db->fieldValue(LanguageTypeTable::C_MODIFY_DATE,$modifydate) ;
		$datas[] = $this->db->fieldValue(LanguageTypeTable::C_CREATE_DATE,$modifydate) ;
		$datas[] = $this->db->fieldValue(LanguageTypeTable::C_BLOCKED,0) ;
		try {
            
			$id = $cls->addRecord($datas) ;
			if ($id > 0) {
				$this->sendJsonResponse(Status::Ok,"Language Type successfully added to the system.",$id,$this->type);
			} else {
				$this->sendJsonResponse(Status::Error,"Sorry, there is a error in adding new Language Type to the system.",$id, $this->type) ;
			}
		} catch (Exception $e) {
			Log::write('[LanguageType]' . $e->getMessage());
			$this->sendJsonResponse(Status::Error,"sorry, there is a error in database operation.","",$this->type) ;
		}
		unset($cls) ;
	}
	private function updateRecord($params) {
		if (isset($params['id'])) {
			$id = $params['id'] ;
			$cls = new LanguageTypeClass($this->db) ;
			try {
				$datas = array() ;
				$modifyby = $_SESSION[SE_USERID] ;
				$modifydate = date_create('now')->format('Y-m-d H:i:s') ;
				$ws = $_SESSION[SE_REMOTE_IP] ;

				$datas[] = $this->db->fieldValue(LanguageTypeTable::C_DESC,$this->getParam($params,'desc',"")) ;
				$datas[] = $this->db->fieldValue(LanguageTypeTable::C_REF,$this->getParam($params,'ref',"")) ;
				$datas[] = $this->db->fieldValue(LanguageTypeTable::C_DISPLAY,$this->getParam($params,'display',"")) ;
				$datas[] = $this->db->fieldValue(LanguageTypeTable::C_WS_ID,$ws) ;
				$datas[] = $this->db->fieldValue(LanguageTypeTable::C_MODIFY_BY,$modifyby) ;
				$datas[] = $this->db->fieldValue(LanguageTypeTable::C_MODIFY_DATE,$modifydate) ;
				$cls->updateRecord($id,$datas) ;
				$this->sendJsonResponse(Status::Ok,"Language Type detail successfully updated to the system.",$id,$this->type) ;
			} catch (Exception $e) {
				Log::write('[LanguageType]' . $e->getMessage());
				$this->sendJsonResponse(Status::Error,"Sorry, there is a error in updating Language Type detail to the system.","",$this->type) ;
			}
			unset($cls) ;
		}else {
			$this->sendJsonResponse(Status::Error,"You must supply the Language Type id you wish to update. Please try again.","",$this->type);
		}
	}
	private function deleteRecord($params) {
		if (isset($params['id'])) {
			$id = $params['id'] ;
			$cls = new LanguageTypeClass($this->db) ;
			try {
				$cls->deleteRecord($id) ; 
				$this->sendJsonResponse(Status::Ok,"Language Type successfully deleted from the system.","",$this->type);
			} catch (Exception $e) {
				Log::write('[LanguageType]' . $e->getMessage());
				$this->sendJsonResponse(Status::Error,"Sorry, there is a problem in deleting Language Type record from the system.","",$this->type) ;
			}
			unset($cls) ;
		} else {
			$this->sendJsonResponse(Status::Error,"You must supply the Language Type id you wish to delete. Please try again.","",$this->type);
		}
	}
	private function getList($params=null) {
		$cls = new LanguageTypeClass($this->db) ;
		$params = array() ;
		$filter = "" ;
		$rows = $cls->getTable($filter,LanguageTypeTable::C_DESC,$params) ;
		$list = "" ;
        Log::write(count($rows));
		foreach ($rows as $row) {
			$id = $row[LanguageTypeTable::C_ID] ;
			$list .= "<tr>" ;
			$list .= "<td>" . $id . "</td>" ;
			$list .= "<td>" . $row[LanguageTypeTable::C_DESC] . "</td>" ;
			$list .= "<td>" . $row[LanguageTypeTable::C_DISPLAY] . "</td>" ;
			$list .= "<td style='text-align:center'><a href='javascript:' onclick='editLanguage(" . $id . ",this)'><img src='image/edit_16.png' title='Edit'></img></a></td>" ;
			$list .= "<td style='text-align:center'><a href='javascript:' onclick='deleteLanguage(" . $id . ",this)'><img src='image/remove_16.png' title='Delete'></img></a></td>" ;
			$list .= "</tr>" ;
		}
        $list;
		unset($rows) ;
		unset($cls) ;
		return $list ;
	}
	private function getRecord($params=null) {
		if (isset($params['id'])) {
			$id = $params['id'] ;
			$cls = new LanguageTypeClass($this->db) ;
			$row = $cls->getRecord($id) ;
			if (is_null($row)) {
				$this->sendJsonResponse(Status::Error,"Invalid Language Type id. Please try again.",$id,$this->type);
			} else {
				$datas = array() ;
				$datas['id'] = $id ;
				$datas['desc'] = $row[LanguageTypeTable::C_DESC];
				$datas['ref'] = $row[LanguageTypeTable::C_REF] ;
				$datas['display'] = $row[LanguageTypeTable::C_DISPLAY] ;
				$this->sendJsonResponse(Status::Ok,"",$datas,$this->type) ;
			}
			unset($cls) ;
		} else {
			$this->sendJsonResponse(Status::Error,"Missing Language Type id. Please try again.","",$this->type);
		}
	}
	private function getView() {
		ob_start() ;
		include (PATH_VIEWS . "admin/LanguageTypeView.php") ;
		echo Util::minifyHtml(ob_get_clean()) ;
	}
	private function getReport($params=null) {
		require_once(PATH_LIB . 'ListPdf.php');
		
		$cls = new LanguageTypeClass($this->db) ;
		$params = array() ;
		$filter = "" ;
		$rows = $cls->getTable($filter,LanguageTypeTable::C_DESC,$params) ;
		$i = 'items';
		$nr = 'newrow';
		$datas = array() ;
		foreach ($rows as $row) {
			$items = array() ;
			$items[$i][] = $this->createPdfItem($row[LanguageTypeTable::C_ID],30) ;
			$items[$i][] = $this->createPdfItem($row[LanguageTypeTable::C_DESC],200) ;
			$items[$i][] = $this->createPdfItem($row[LanguageTypeTable::C_DISPLAY],100) ;
			$items[$nr] = "1" ;
			$datas[] = $items ;
		}
		$cols = array() ;
		$cols[] = $this->createPdfItem("ID",30,0,"C","B");
		$cols[] = $this->createPdfItem("Description",200,0,"C","B") ;
		$cols[] = $this->createPdfItem("Display",100,0,"C","B") ;
		$pdf = new ListPdf('P');
		$pdf->setCompanyName($_SESSION[SE_COYNAME]) ;
		$pdf->setReportTitle("Language Type Listing") ;
		$pdf->setColumnsHeader($cols) ;
		$pdf->render($datas) ;
		$pdf->Output('languagetype.pdf', 'I');
		unset($rows) ;
		unset($cls) ;
		unset($datas) ;
		unset($params) ;
		unset($items) ;
		unset($cols) ;
	}
}
?>